Debian Bug report logs - #172339
[dpkgpm] Packages with circular dependencies may fail due to being configured in different dpkg invocations when installing many packages

version graph

Package: apt; Maintainer for apt is APT Development Team <deity@lists.debian.org>; Source for apt is src:apt.

Reported by: Rene Engelhard <rene@debian.org>

Date: Mon, 9 Dec 2002 12:18:01 UTC

Severity: important

Merged with 190558, 283923

Found in version 0.5.4

Done: Christian Perrier <bubulle@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>, apt@packages.qa.debian.org:
Bug#172339; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Rene Engelhard <rene@debian.org>:
New Bug report received and forwarded. Copy sent to APT Development Team <deity@lists.debian.org>, apt@packages.qa.debian.org. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Rene Engelhard <rene@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Cc: Joey Hess <joeyh@debian.org>, 172057@bugs.debian.org, Gaute Hvoslef Kvalnes <gaute@verdsveven.com>
Subject: apt feeds packages with circular deps to dpkg problematically
Date: Mon, 9 Dec 2002 13:07:04 +0100
[Message part 1 (text/plain, inline)]
Package: apt
Version: 0.5.4
Severity: important

Hi,

it seems that joeyh's Mail was not regognized. So I file a new Bug
instead:

Joey wrote:

--- snip ---
Package: apt
Version: probably 0.5.4

Gaute Hvoslef Kvalnes wrote:

Gaute Hvoslef Kvalnes wrote:
> There's a (Norwegian) bug report at Skulelinux:
>
> <URL: http://bugs.skulelinux.no/show_bug.cgi?id=220 >
>
> ... with this installation log, from which the excerpt in bug#165036 was
> retrieved:
>
> <URL: http://bugs.skulelinux.no/showattachment.cgi?attach_id=29 >
>
> I don't see any sign of openoffice.org failing to configure. dpkg just tries
> to configure openoffice.org-l10n-en first, and fails.The order of
> configuration seems random. Another installation log, using a slightly
> different set of packages, chooses openoffice.org first and succeeds:


I've talked to the dpkg people, and dpkg apparently will do the right
thing if asked to configure both packages in the cycle in the same dpkg
run. (Namely, it will break the cycle.) As near as we can tell, what
happens in this transcript is apt is panicing because so many packages
are to be installed, and feeding them to dpkg --unpack in chunks. Then
at the end, it is using dpkg --configure, and instead of doing just a
single configure run with --all or a full list of packages, it is
passing it small shunks of packages to configure. Or maybe just one at a
time..

Either way, in this case dpkg is asked to configure
openoffice.org-l10n-en and is not asked to configure openoffice.org in
the same run. And so it blows up.

So this doesn't just effect openoffice, but can randomly affect any pair
of packages with a dependency cycle if they're installed along with a
lot of other packages and apt begins chunking things like this. So it'll
tend to hit new debian installs.

From irc:

<elmo_home> I think this is the apt thing where it has a hardcoded limit
on how much it'll feed dpkg in any one go
<wiggy> apt seems to always do that
<wiggy> elmo_home: could very well be
<joeyh> so it tells dpkg to just unpack stuff in the first run? Yugh
<elmo_home> and it's basically set too low if you're installing a bucket
load of packages.. mostly it only bites buildds, but if this is a
freshish install it could bite you there too
<Kamion> apt CVS appears to make that configurable
<Kamion> I don't understand why it can't just be nuked though - kernel
argv limits?
<elmo_home> Kamion: apparently it broke older dpkg's and culus is
paranoid *shrug*

Apt could use bigger chunks (making this scenario much less likely
anyhow), or use the new dpkg control pipe stuff, or I suppose it could
detect cycles and make sure dpkg is asked to configure them all at the
same time,

Until this is fixed, you OOo guys might be justified in removing the
cycle. Of course since any of our many other dependency cycles can also
trigger the behavior, that is as best a very weak workaround.

--- snip ---

Regards,

Rene

-- System Information:
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux stan 2.4.18 #1 Son Nov 3 01:29:12 CET 2002 i686
Locale: LANG=de_DE@euro, LC_CTYPE=de_DE@euro

Versions of packages apt depends on:
ii  libc6                        2.3.1-5     GNU C Library: Shared libraries an
ii  libstdc++2.10-glibc2.2       1:2.95.4-15 The GNU stdc++ library

-- no debconf information


-- 
 .''`.  Rene Engelhard -- Debian GNU/Linux Developer
 : :' : http://www.debian.org | http://people.debian.org/~rene/
 `. `'  rene@debian.org | GnuPG-Key ID: 248AEB73
   `-   Fingerprint: 41FA F208 28D4 7CA5 19BB  7AD9 F859 90B0 248A EB73
[Message part 2 (application/pgp-signature, inline)]

Merged 172339 190558. Request was from Rene Engelhard <rene@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#172339; Package apt. Full text and rfc822 format available.

Acknowledgement sent to Matt Zimmerman <mdz@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. Full text and rfc822 format available.

Message #12 received at 172339@bugs.debian.org (full text, mbox):

From: Matt Zimmerman <mdz@debian.org>
To: 172339@bugs.debian.org
Subject: downgrade and merge
Date: Fri, 18 Jul 2003 12:07:29 -0400
severity 172339 normal
severity 22550 normal
merge 172339 22550
thanks

In 0.5.5, there are configurable limits for the length of the dpkg command
line, and the default was increased from 1024 bytes to 8192 bytes, so this
should not be a significant problem anymore.  Downgrading and merging with
the old wishlist bug about the same issue.

-- 
 - mdz



Severity set to `normal'. Request was from Matt Zimmerman <mdz@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Merged 22550 172339 190558. Request was from Matt Zimmerman <mdz@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title. Request was from Matt Zimmerman <mdz@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title. Request was from Matt Zimmerman <mdz@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Disconnected #22550 from all other report(s). Request was from Matt Zimmerman <mdz@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Severity set to `important'. Request was from Christian Perrier <bubulle@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Merged 172339 190558 283923. Request was from Christian Perrier <bubulle@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Reply sent to Christian Perrier <bubulle@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Rene Engelhard <rene@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #31 received at 283923-done@bugs.debian.org (full text, mbox):

From: Christian Perrier <bubulle@debian.org>
To: Joey Hess <joeyh@debian.org>, 283923-done@bugs.debian.org
Subject: Re: Bug#283923: close?
Date: Thu, 20 Jan 2005 22:52:52 +0100
Quoting Joey Hess (joeyh@debian.org):
> AFAIK this bug is fixed and can be closed. All the tasks are
> successfully installing with the new apt.


As the bug reporter, I confirm this. I even didn't remembered that
Matt didn't closit, waiting for input about it.

Hence closing myself.

Thanks for the reminder. We may probably now revive the things you
disabled in tasks, don't you thinkĀ (changes in tasksel 2.18)?

These myspell-* packages are of some importance for good working
localized OO installs.





Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 18:49:21 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.